import { initCanvas, getRect } from "./canvas.js";
import { queueflush, scheduledDom } from "./scheduler.js";
function VueChangeMarker() {
  initCanvas();
  registerDevtoolsHook();
}
function emit(event, ...payload) {
  var _a;
  if (event === "component:updated") {
    const updatedInstance = payload[3];
    const type = (_a = updatedInstance.vnode.type) == null ? void 0 : _a.toString();
    if (type === "Symbol(v-fgt)") return;
    const el = updatedInstance.vnode.el;
    if (!el) return;
    if (!el.getBoundingClientRect) return;
    const rect = getRect(el);
    if (rect) {
      scheduledDom.push({ dom: el, updatedInstance });
    }
    queueflush();
  }
}
function registerDevtoolsHook() {
  var _a;
  if (((_a = window.__VUE_DEVTOOLS_GLOBAL_HOOK__) == null ? void 0 : _a.id) !== "vue-change-marker") {
    const oldEmit = window.__VUE_DEVTOOLS_GLOBAL_HOOK__.emit;
    window.__VUE_DEVTOOLS_GLOBAL_HOOK__.emit = function(...args) {
      oldEmit.call(window.__VUE_DEVTOOLS_GLOBAL_HOOK__, ...args);
      emit(...args);
    };
  }
  if (!window.__VUE_DEVTOOLS_GLOBAL_HOOK__) {
    window.__VUE_DEVTOOLS_GLOBAL_HOOK__ = { id: "vue-change-marker", emit };
  }
}
export {
  VueChangeMarker
};
