import { highlight, clearCanvas, resetCounters, ctx } from "./canvas.js";
let isPending = false;
let timer = 0;
const scheduledDom = [];
function flush() {
  const item = scheduledDom[0];
  if (item) {
    const { dom, updatedInstance } = item;
    requestAnimationFrame(() => {
      highlight(ctx, dom, updatedInstance);
      scheduledDom.shift();
      if (scheduledDom.length) {
        requestAnimationFrame(flush);
      } else {
        isPending = false;
        clearTimeout(timer);
        timer = window.setTimeout(() => {
          clearCanvas(ctx);
          resetCounters();
        }, 300);
      }
    });
  }
}
const queueflush = async () => {
  if (!isPending) {
    isPending = true;
    flush();
  }
};
export {
  queueflush,
  scheduledDom
};
